package sensei.middleware.domains;


/**
* sensei/middleware/domains/BasicStateHandlerPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/***********************************************************************/
public class BasicStateHandlerPOATie extends BasicStateHandlerPOA
{

  // Constructors

  public BasicStateHandlerPOATie ( sensei.middleware.domains.BasicStateHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public BasicStateHandlerPOATie ( sensei.middleware.domains.BasicStateHandlerOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.domains.BasicStateHandlerOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.domains.BasicStateHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }
  public void assumeState ()
  {
    _impl.assumeState();
  } // assumeState

  public void startTransfer (int[] joiningMembers, sensei.middleware.domains.PhaseCoordinationHolder phase)
  {
    _impl.startTransfer(joiningMembers, phase);
  } // startTransfer

  public sensei.middleware.domains.State getState (sensei.middleware.domains.PhaseCoordinationHolder phase)
  {
    return _impl.getState(phase);
  } // getState

  public void setState (sensei.middleware.domains.State s, sensei.middleware.domains.PhaseCoordination phase)
  {
    _impl.setState(s, phase);
  } // setState

  public void stopTransfer (int[] joiningMembers, boolean transferFinished)
  {
    _impl.stopTransfer(joiningMembers, transferFinished);
  } // stopTransfer


  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
  public void processPTPMessage (int sender, sensei.middleware.gms.Message msg)
  {
    _impl.processPTPMessage(sender, msg);
  } // processPTPMessage


  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
  public void processCastMessage (int sender, sensei.middleware.gms.Message msg)
  {
    _impl.processCastMessage(sender, msg);
  } // processCastMessage


  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
  public void memberAccepted (int identity, sensei.middleware.gms.GroupHandler handler, sensei.middleware.gms.View theView)
  {
    _impl.memberAccepted(identity, handler, theView);
  } // memberAccepted


  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
  public void changingView ()
  {
    _impl.changingView();
  } // changingView


  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
  public void installView (sensei.middleware.gms.View theView)
  {
    _impl.installView(theView);
  } // installView


  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
  public void excludedFromGroup ()
  {
    _impl.excludedFromGroup();
  } // excludedFromGroup

  private sensei.middleware.domains.BasicStateHandlerOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class BasicStateHandlerPOATie
