package sensei.middleware.domains;


/**
* sensei/middleware/domains/DomainGroupHandlerHelper.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
        * GroupMember targetted as central instance to handle several subgroups
        * Messages sent through this class must belong to the DomainMessage hierarchy
        *
        *   -	It allows to define several subgroups to be handled separately by one group.
        *   - The subgroups can be created/removed dynamically.
        *   -	It includes the abstraction group/subgroups or domain/groups
        * It supports several special features:
        * -The sending of messages blocks the caller until the message is received
        * -Reception of cast messages sent by the own member are not propagated to the
        *    subgroups: they just unblock the message sending.
        * -PTP messages can be sent to all the subgroups in the group
        * -State transfer support
        * -Replica properties support
        * -Transactions support
        **/
abstract public class DomainGroupHandlerHelper
{
  private static String  _id = "IDL:sensei/middleware/domains/DomainGroupHandler:1.0";

  public static void insert (org.omg.CORBA.Any a, sensei.middleware.domains.DomainGroupHandler that)
  {
    org.omg.CORBA.portable.OutputStream out = a.create_output_stream ();
    a.type (type ());
    write (out, that);
    a.read_value (out.create_input_stream (), type ());
  }

  public static sensei.middleware.domains.DomainGroupHandler extract (org.omg.CORBA.Any a)
  {
    return read (a.create_input_stream ());
  }

  private static org.omg.CORBA.TypeCode __typeCode = null;
  synchronized public static org.omg.CORBA.TypeCode type ()
  {
    if (__typeCode == null)
    {
      __typeCode = org.omg.CORBA.ORB.init ().create_interface_tc (sensei.middleware.domains.DomainGroupHandlerHelper.id (), "DomainGroupHandler");
    }
    return __typeCode;
  }

  public static String id ()
  {
    return _id;
  }

  public static sensei.middleware.domains.DomainGroupHandler read (org.omg.CORBA.portable.InputStream istream)
  {
    return narrow (istream.read_Object (_DomainGroupHandlerStub.class));
  }

  public static void write (org.omg.CORBA.portable.OutputStream ostream, sensei.middleware.domains.DomainGroupHandler value)
  {
    ostream.write_Object ((org.omg.CORBA.Object) value);
  }

  public static sensei.middleware.domains.DomainGroupHandler narrow (org.omg.CORBA.Object obj)
  {
    if (obj == null)
      return null;
    else if (obj instanceof sensei.middleware.domains.DomainGroupHandler)
      return (sensei.middleware.domains.DomainGroupHandler)obj;
    else if (!obj._is_a (id ()))
      throw new org.omg.CORBA.BAD_PARAM ();
    else
    {
      org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate ();
      sensei.middleware.domains._DomainGroupHandlerStub stub = new sensei.middleware.domains._DomainGroupHandlerStub ();
      stub._set_delegate(delegate);
      return stub;
    }
  }

}
