package sensei.middleware.domains;


/**
* sensei/middleware/domains/DomainMessage.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/**
       * A DomainMessage includes some additional information to handle
       * the extended functionality
       */
public abstract class DomainMessage extends sensei.middleware.gms.Message
{

 //subgroup is the only field to be usually filled by the application
  public int subgroup = (int)0;

 //following fields should be false by default
  public boolean unqueuedOnST = false;

 //to true if the message is NOT queued during state transfers
  public boolean unTransactionable = false;

 //following fields are used by the domains package
  public boolean waitReception = false;

 //to false (default) if the sending does not wait until the member receives it.
  public int id = (int)0;

  private static String[] _truncatable_ids = {
    sensei.middleware.domains.DomainMessageHelper.id ()
  };

  public String[] _truncatable_ids() {
    return _truncatable_ids;
  }

  public void _read (org.omg.CORBA.portable.InputStream istream)
  {
    super._read (istream);
    this.subgroup = istream.read_long ();
    this.unqueuedOnST = istream.read_boolean ();
    this.unTransactionable = istream.read_boolean ();
    this.waitReception = istream.read_boolean ();
    this.id = istream.read_long ();
  }

  public void _write (org.omg.CORBA.portable.OutputStream ostream)
  {
    super._write (ostream);
    ostream.write_long (this.subgroup);
    ostream.write_boolean (this.unqueuedOnST);
    ostream.write_boolean (this.unTransactionable);
    ostream.write_boolean (this.waitReception);
    ostream.write_long (this.id);
  }

  public org.omg.CORBA.TypeCode _type ()
  {
    return sensei.middleware.domains.DomainMessageHelper.type ();
  }
} // class DomainMessage
