package sensei.middleware.domains;


/**
* sensei/middleware/domains/DynamicSubgroupsUserOperations.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/**
       * Defines the interface to be used by members using the SubgroupsHandler interface
       * with dynamic groups
       */
public interface DynamicSubgroupsUserOperations 
{

  /**
           * Request during state transfer to accept an existing dynamic subgroup; a subgroup must be returned,
           */
  sensei.middleware.gms.GroupMember acceptSubgroup (int id, sensei.middleware.domains.DynamicSubgroupInfo info);

  /**
           * Notification that a subgroup has been dynamically created. A subgroup must be returned,
           */
  sensei.middleware.gms.GroupMember subgroupCreated (int creator, int id, sensei.middleware.domains.DynamicSubgroupInfo info);

  /**
           * Notification that a subgroup has been dynamically removed.
           */
  void subgroupRemoved (int remover, int id, sensei.middleware.domains.DynamicSubgroupInfo info);
} // interface DynamicSubgroupsUserOperations
