package sensei.middleware.domains;


/**
* sensei/middleware/domains/MessageC.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
       *  Message c is the reply message sent from a DomainGroupHandler that
       *  has received the message p. It contains its properties, and the
       *  coordination phases of the subgroups
       **/
public abstract class MessageC extends sensei.middleware.domains.DomainMessage
{
  public int viewId = (int)0;

 //message can only be processed on the right view, depending on the model
  public sensei.middleware.domains.SubgroupCoordination coordinations[] = null;
  public boolean containOwnProperties = false;

 //true if the next field props is valid
  public sensei.middleware.domains.Property props[] = null;

  private static String[] _truncatable_ids = {
    sensei.middleware.domains.MessageCHelper.id ()
  };

  public String[] _truncatable_ids() {
    return _truncatable_ids;
  }

  public void _read (org.omg.CORBA.portable.InputStream istream)
  {
    super._read (istream);
    this.viewId = istream.read_long ();
    this.coordinations = sensei.middleware.domains.SubgroupCoordinationsHelper.read (istream);
    this.containOwnProperties = istream.read_boolean ();
    this.props = sensei.middleware.domains.PropertiesHelper.read (istream);
  }

  public void _write (org.omg.CORBA.portable.OutputStream ostream)
  {
    super._write (ostream);
    ostream.write_long (this.viewId);
    sensei.middleware.domains.SubgroupCoordinationsHelper.write (ostream, this.coordinations);
    ostream.write_boolean (this.containOwnProperties);
    sensei.middleware.domains.PropertiesHelper.write (ostream, this.props);
  }

  public org.omg.CORBA.TypeCode _type ()
  {
    return sensei.middleware.domains.MessageCHelper.type ();
  }
} // class MessageC
