package sensei.middleware.domains;


/**
* sensei/middleware/domains/MessageE.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
       *  Message e is sent when a transfer has finished, containing
       *  the member that has received the state and its properties
       **/
public abstract class MessageE extends sensei.middleware.domains.DomainMessage
{
  public int viewId = (int)0;

 //message can only be processed on the right view, depending on the model
  public int member = (int)0;
  public sensei.middleware.domains.Property props[] = null;

  private static String[] _truncatable_ids = {
    sensei.middleware.domains.MessageEHelper.id ()
  };

  public String[] _truncatable_ids() {
    return _truncatable_ids;
  }

  public void _read (org.omg.CORBA.portable.InputStream istream)
  {
    super._read (istream);
    this.viewId = istream.read_long ();
    this.member = istream.read_long ();
    this.props = sensei.middleware.domains.PropertiesHelper.read (istream);
  }

  public void _write (org.omg.CORBA.portable.OutputStream ostream)
  {
    super._write (ostream);
    ostream.write_long (this.viewId);
    ostream.write_long (this.member);
    sensei.middleware.domains.PropertiesHelper.write (ostream, this.props);
  }

  public org.omg.CORBA.TypeCode _type ()
  {
    return sensei.middleware.domains.MessageEHelper.type ();
  }
} // class MessageE
