package sensei.middleware.domains;


/**
* sensei/middleware/domains/MessagePHelper.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
       *  Message p is the initial message sent between DomainGroupHandlers to
       *  transfer their features, and any state transfer information required
       *  (but not the state itself).
       *  It contains:
       *  (a) generic information about the group itself
       *  (b) information about the subgroup layout
       *  (c) list of current statefull members, with their properties and
       *      members being coordinated
       **/
abstract public class MessagePHelper
{
  private static String  _id = "IDL:sensei/middleware/domains/MessageP:1.0";


  public static void insert (org.omg.CORBA.Any a, sensei.middleware.domains.MessageP that)
  {
    org.omg.CORBA.portable.OutputStream out = a.create_output_stream ();
    a.type (type ());
    write (out, that);
    a.read_value (out.create_input_stream (), type ());
  }

  public static sensei.middleware.domains.MessageP extract (org.omg.CORBA.Any a)
  {
    return read (a.create_input_stream ());
  }

  private static org.omg.CORBA.TypeCode __typeCode = null;
  private static boolean __active = false;
  synchronized public static org.omg.CORBA.TypeCode type ()
  {
    if (__typeCode == null)
    {
      synchronized (org.omg.CORBA.TypeCode.class)
      {
        if (__typeCode == null)
        {
          if (__active)
          {
            return org.omg.CORBA.ORB.init().create_recursive_tc ( _id );
          }
          __active = true;
          org.omg.CORBA.ValueMember[] _members0 = new org.omg.CORBA.ValueMember[8];
          org.omg.CORBA.TypeCode _tcOf_members0 = null;
          // ValueMember instance for viewId
          _tcOf_members0 = org.omg.CORBA.ORB.init ().get_primitive_tc (org.omg.CORBA.TCKind.tk_long);
          _members0[0] = new org.omg.CORBA.ValueMember ("viewId", 
              "", 
              _id, 
              "", 
              _tcOf_members0, 
              null, 
              org.omg.CORBA.PUBLIC_MEMBER.value);
          // ValueMember instance for behaviour
          _tcOf_members0 = sensei.middleware.domains.BehaviourOnViewChangesHelper.type ();
          _members0[1] = new org.omg.CORBA.ValueMember ("behaviour", 
              sensei.middleware.domains.BehaviourOnViewChangesHelper.id (), 
              _id, 
              "1.0", 
              _tcOf_members0, 
              null, 
              org.omg.CORBA.PUBLIC_MEMBER.value);
          // ValueMember instance for coordinatorElectorRegistered
          _tcOf_members0 = org.omg.CORBA.ORB.init ().get_primitive_tc (org.omg.CORBA.TCKind.tk_boolean);
          _members0[2] = new org.omg.CORBA.ValueMember ("coordinatorElectorRegistered", 
              "", 
              _id, 
              "", 
              _tcOf_members0, 
              null, 
              org.omg.CORBA.PUBLIC_MEMBER.value);
          // ValueMember instance for dynamicSubgroupsAllowed
          _tcOf_members0 = org.omg.CORBA.ORB.init ().get_primitive_tc (org.omg.CORBA.TCKind.tk_boolean);
          _members0[3] = new org.omg.CORBA.ValueMember ("dynamicSubgroupsAllowed", 
              "", 
              _id, 
              "", 
              _tcOf_members0, 
              null, 
              org.omg.CORBA.PUBLIC_MEMBER.value);
          // ValueMember instance for nextDynamicSubgroupId
          _tcOf_members0 = org.omg.CORBA.ORB.init ().get_primitive_tc (org.omg.CORBA.TCKind.tk_long);
          _members0[4] = new org.omg.CORBA.ValueMember ("nextDynamicSubgroupId", 
              "", 
              _id, 
              "", 
              _tcOf_members0, 
              null, 
              org.omg.CORBA.PUBLIC_MEMBER.value);
          // ValueMember instance for subgroupsInformation
          _tcOf_members0 = sensei.middleware.domains.SubgroupPropertiesHelper.type ();
          _tcOf_members0 = org.omg.CORBA.ORB.init ().create_sequence_tc (0, _tcOf_members0);
          _tcOf_members0 = org.omg.CORBA.ORB.init ().create_alias_tc (sensei.middleware.domains.SubgroupsInfoHelper.id (), "SubgroupsInfo", _tcOf_members0);
          _members0[5] = new org.omg.CORBA.ValueMember ("subgroupsInformation", 
              sensei.middleware.domains.SubgroupsInfoHelper.id (), 
              _id, 
              "1.0", 
              _tcOf_members0, 
              null, 
              org.omg.CORBA.PUBLIC_MEMBER.value);
          // ValueMember instance for props
          _tcOf_members0 = sensei.middleware.domains.MemberPropertiesHelper.type ();
          _tcOf_members0 = org.omg.CORBA.ORB.init ().create_sequence_tc (0, _tcOf_members0);
          _tcOf_members0 = org.omg.CORBA.ORB.init ().create_alias_tc (sensei.middleware.domains.MemberPropertiesListHelper.id (), "MemberPropertiesList", _tcOf_members0);
          _members0[6] = new org.omg.CORBA.ValueMember ("props", 
              sensei.middleware.domains.MemberPropertiesListHelper.id (), 
              _id, 
              "1.0", 
              _tcOf_members0, 
              null, 
              org.omg.CORBA.PUBLIC_MEMBER.value);
          // ValueMember instance for replicasInfo
          _tcOf_members0 = sensei.middleware.domains.ReplicaInformationHelper.type ();
          _tcOf_members0 = org.omg.CORBA.ORB.init ().create_sequence_tc (0, _tcOf_members0);
          _tcOf_members0 = org.omg.CORBA.ORB.init ().create_alias_tc (sensei.middleware.domains.ReplicasInformationHelper.id (), "ReplicasInformation", _tcOf_members0);
          _members0[7] = new org.omg.CORBA.ValueMember ("replicasInfo", 
              sensei.middleware.domains.ReplicasInformationHelper.id (), 
              _id, 
              "1.0", 
              _tcOf_members0, 
              null, 
              org.omg.CORBA.PUBLIC_MEMBER.value);
          __typeCode = org.omg.CORBA.ORB.init ().create_value_tc (_id, "MessageP", org.omg.CORBA.VM_NONE.value, sensei.middleware.domains.DomainMessageHelper.type (), _members0);
          __active = false;
        }
      }
    }
    return __typeCode;
  }

  public static String id ()
  {
    return _id;
  }

  public static sensei.middleware.domains.MessageP read (org.omg.CORBA.portable.InputStream istream)
  {
    return (sensei.middleware.domains.MessageP)((org.omg.CORBA_2_3.portable.InputStream) istream).read_value (id ());
  }

  public static void write (org.omg.CORBA.portable.OutputStream ostream, sensei.middleware.domains.MessageP value)
  {
    ((org.omg.CORBA_2_3.portable.OutputStream) ostream).write_value (value, id ());
  }


}
