package sensei.middleware.domains;


/**
* sensei/middleware/domains/MonitorOperations.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/

public interface MonitorOperations 
{

  /**
            * Locks the monitor.
            * This locking is reentrant: the member acquiring it can lock it again.
            * As a consequence, if the member intends to access the monitor from
            * different threads, it will have to include the synchronization
            * by itself
            **/
  void lock () throws sensei.middleware.domains.MemberStateException;

  /**
            * Unlocks the monitor;
            * @throws MonitorException if the monitor was not locked by this member
            **/
  void unlock () throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.MemberStateException;
} // interface MonitorOperations
