package sensei.middleware.domains;


/**
* sensei/middleware/domains/MonitorPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/

public abstract class MonitorPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.domains.MonitorOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("lock", new java.lang.Integer (0));
    _methods.put ("unlock", new java.lang.Integer (1));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
            * Locks the monitor.
            * This locking is reentrant: the member acquiring it can lock it again.
            * As a consequence, if the member intends to access the monitor from
            * different threads, it will have to include the synchronization
            * by itself
            **/
       case 0:  // sensei/middleware/domains/Monitor/lock
       {
         try {
           this.lock ();
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Unlocks the monitor;
            * @throws MonitorException if the monitor was not locked by this member
            **/
       case 1:  // sensei/middleware/domains/Monitor/unlock
       {
         try {
           this.unlock ();
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MonitorException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MonitorExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/Monitor:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public Monitor _this() 
  {
    return MonitorHelper.narrow(
    super._this_object());
  }

  public Monitor _this(org.omg.CORBA.ORB orb) 
  {
    return MonitorHelper.narrow(
    super._this_object(orb));
  }


} // class MonitorPOA
