package sensei.middleware.domains;


/**
* sensei/middleware/domains/MonitorPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/

public class MonitorPOATie extends MonitorPOA
{

  // Constructors

  public MonitorPOATie ( sensei.middleware.domains.MonitorOperations delegate ) {
      this._impl = delegate;
  }
  public MonitorPOATie ( sensei.middleware.domains.MonitorOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.domains.MonitorOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.domains.MonitorOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
            * Locks the monitor.
            * This locking is reentrant: the member acquiring it can lock it again.
            * As a consequence, if the member intends to access the monitor from
            * different threads, it will have to include the synchronization
            * by itself
            **/
  public void lock () throws sensei.middleware.domains.MemberStateException
  {
    _impl.lock();
  } // lock


  /**
            * Unlocks the monitor;
            * @throws MonitorException if the monitor was not locked by this member
            **/
  public void unlock () throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.MemberStateException
  {
    _impl.unlock();
  } // unlock

  private sensei.middleware.domains.MonitorOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class MonitorPOATie
