package sensei.middleware.domains;


/**
* sensei/middleware/domains/TransactionsHandlerPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/

public abstract class TransactionsHandlerPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.domains.TransactionsHandlerOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("startTransaction", new java.lang.Integer (0));
    _methods.put ("endTransaction", new java.lang.Integer (1));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
           * Starts a transaction, locking first the given monitor.
           * Transactions can be nested, but nested transactions only end when the initial transaction
           * is finished.
           * A system on a transaction does not start any state transfer, and all the messages
           * sent by the group handler are queued until the transaction ends. As the result, messages
           * can be seen by other members in different views, and this interface is therefore only
           * allowed under mode MembersOnTransferExcludedFromGroup.
           * @exception MonitorException if the monitor is not valid
           * @exception TransactionException if transactions are not allowed
           */
       case 0:  // sensei/middleware/domains/TransactionsHandler/startTransaction
       {
         try {
           sensei.middleware.domains.Monitor locker = sensei.middleware.domains.MonitorHelper.read (in);
           this.startTransaction (locker);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MonitorException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MonitorExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.TransactionException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.TransactionExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Ends a transaction, unlocking the given monitor. The operation only takes place, in case
           * of nested transactions, when the initial transaction ends.
           * @exception MonitorException if the monitor used for the transaction has been unlocked inside
           *            the transaction
           * @exception TransactionException if transactions are not allowed, or there is not any current transaction
           */
       case 1:  // sensei/middleware/domains/TransactionsHandler/endTransaction
       {
         try {
           this.endTransaction ();
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MonitorException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MonitorExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.TransactionException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.TransactionExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/TransactionsHandler:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public TransactionsHandler _this() 
  {
    return TransactionsHandlerHelper.narrow(
    super._this_object());
  }

  public TransactionsHandler _this(org.omg.CORBA.ORB orb) 
  {
    return TransactionsHandlerHelper.narrow(
    super._this_object(orb));
  }


} // class TransactionsHandlerPOA
