package sensei.middleware.domains;


/**
* sensei/middleware/domains/TransactionsHandlerPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/

public class TransactionsHandlerPOATie extends TransactionsHandlerPOA
{

  // Constructors

  public TransactionsHandlerPOATie ( sensei.middleware.domains.TransactionsHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public TransactionsHandlerPOATie ( sensei.middleware.domains.TransactionsHandlerOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.domains.TransactionsHandlerOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.domains.TransactionsHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
           * Starts a transaction, locking first the given monitor.
           * Transactions can be nested, but nested transactions only end when the initial transaction
           * is finished.
           * A system on a transaction does not start any state transfer, and all the messages
           * sent by the group handler are queued until the transaction ends. As the result, messages
           * can be seen by other members in different views, and this interface is therefore only
           * allowed under mode MembersOnTransferExcludedFromGroup.
           * @exception MonitorException if the monitor is not valid
           * @exception TransactionException if transactions are not allowed
           */
  public void startTransaction (sensei.middleware.domains.Monitor locker) throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException
  {
    _impl.startTransaction(locker);
  } // startTransaction


  /**
           * Ends a transaction, unlocking the given monitor. The operation only takes place, in case
           * of nested transactions, when the initial transaction ends.
           * @exception MonitorException if the monitor used for the transaction has been unlocked inside
           *            the transaction
           * @exception TransactionException if transactions are not allowed, or there is not any current transaction
           */
  public void endTransaction () throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException
  {
    _impl.endTransaction();
  } // endTransaction

  private sensei.middleware.domains.TransactionsHandlerOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class TransactionsHandlerPOATie
