package sensei.middleware.domains;


/**
* sensei/middleware/domains/_DynamicSubgroupsUserStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/**
       * Defines the interface to be used by members using the SubgroupsHandler interface
       * with dynamic groups
       */
public class _DynamicSubgroupsUserStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.domains.DynamicSubgroupsUser
{


  /**
           * Request during state transfer to accept an existing dynamic subgroup; a subgroup must be returned,
           */
  public sensei.middleware.gms.GroupMember acceptSubgroup (int id, sensei.middleware.domains.DynamicSubgroupInfo info)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("acceptSubgroup", true);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, id);
                sensei.middleware.domains.DynamicSubgroupInfoHelper.write ($out, info);
                $in = _invoke ($out);
                sensei.middleware.gms.GroupMember $result = sensei.middleware.domains.GroupMemberHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return acceptSubgroup (id, info        );
            } finally {
                _releaseReply ($in);
            }
  } // acceptSubgroup


  /**
           * Notification that a subgroup has been dynamically created. A subgroup must be returned,
           */
  public sensei.middleware.gms.GroupMember subgroupCreated (int creator, int id, sensei.middleware.domains.DynamicSubgroupInfo info)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("subgroupCreated", true);
                sensei.middleware.domains.GroupMemberIdHelper.write ($out, creator);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, id);
                sensei.middleware.domains.DynamicSubgroupInfoHelper.write ($out, info);
                $in = _invoke ($out);
                sensei.middleware.gms.GroupMember $result = sensei.middleware.domains.GroupMemberHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return subgroupCreated (creator, id, info        );
            } finally {
                _releaseReply ($in);
            }
  } // subgroupCreated


  /**
           * Notification that a subgroup has been dynamically removed.
           */
  public void subgroupRemoved (int remover, int id, sensei.middleware.domains.DynamicSubgroupInfo info)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("subgroupRemoved", true);
                sensei.middleware.domains.GroupMemberIdHelper.write ($out, remover);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, id);
                sensei.middleware.domains.DynamicSubgroupInfoHelper.write ($out, info);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                subgroupRemoved (remover, id, info        );
            } finally {
                _releaseReply ($in);
            }
  } // subgroupRemoved

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/DynamicSubgroupsUser:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _DynamicSubgroupsUserStub
