package sensei.middleware.gmns;


/**
* sensei/middleware/gmns/GroupHandlerFactoryCreator.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:18:51 PM CET
*/


/**
        * ValueType that creates GroupHandlerFactories on
        * demand. This is not a remote object, the intention is to
        * create the GroupHandler in the local memory belonging to the
        * group member, and therefore avoid new points of failure.
        * If the GroupHandler would be created directly by any of the
        * membership services, the failure of the service would suppose
        * the failure of the associated GroupMember
        **/
public abstract class GroupHandlerFactoryCreator implements org.omg.CORBA.portable.StreamableValue
{
  private static String[] _truncatable_ids = {
    sensei.middleware.gmns.GroupHandlerFactoryCreatorHelper.id ()
  };

  public String[] _truncatable_ids() {
    return _truncatable_ids;
  }


  /**
            * Creates a new handler factory for the given member
            **/
  public abstract sensei.middleware.gmns.GroupHandlerFactory create (sensei.middleware.gms.GroupMember member) throws sensei.middleware.gmns.GroupHandlerFactoryException;

  public void _read (org.omg.CORBA.portable.InputStream istream)
  {
  }

  public void _write (org.omg.CORBA.portable.OutputStream ostream)
  {
  }

  public org.omg.CORBA.TypeCode _type ()
  {
    return sensei.middleware.gmns.GroupHandlerFactoryCreatorHelper.type ();
  }
} // class GroupHandlerFactoryCreator
