package sensei.middleware.gmns;


/**
* sensei/middleware/gmns/GroupHandlerFactoryCreatorHelper.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:18:51 PM CET
*/


/**
        * ValueType that creates GroupHandlerFactories on
        * demand. This is not a remote object, the intention is to
        * create the GroupHandler in the local memory belonging to the
        * group member, and therefore avoid new points of failure.
        * If the GroupHandler would be created directly by any of the
        * membership services, the failure of the service would suppose
        * the failure of the associated GroupMember
        **/
abstract public class GroupHandlerFactoryCreatorHelper
{
  private static String  _id = "IDL:sensei/middleware/gmns/GroupHandlerFactoryCreator:1.0";


  public static void insert (org.omg.CORBA.Any a, sensei.middleware.gmns.GroupHandlerFactoryCreator that)
  {
    org.omg.CORBA.portable.OutputStream out = a.create_output_stream ();
    a.type (type ());
    write (out, that);
    a.read_value (out.create_input_stream (), type ());
  }

  public static sensei.middleware.gmns.GroupHandlerFactoryCreator extract (org.omg.CORBA.Any a)
  {
    return read (a.create_input_stream ());
  }

  private static org.omg.CORBA.TypeCode __typeCode = null;
  private static boolean __active = false;
  synchronized public static org.omg.CORBA.TypeCode type ()
  {
    if (__typeCode == null)
    {
      synchronized (org.omg.CORBA.TypeCode.class)
      {
        if (__typeCode == null)
        {
          if (__active)
          {
            return org.omg.CORBA.ORB.init().create_recursive_tc ( _id );
          }
          __active = true;
          org.omg.CORBA.ValueMember[] _members0 = new org.omg.CORBA.ValueMember[0];
          org.omg.CORBA.TypeCode _tcOf_members0 = null;
          __typeCode = org.omg.CORBA.ORB.init ().create_value_tc (_id, "GroupHandlerFactoryCreator", org.omg.CORBA.VM_NONE.value, null, _members0);
          __active = false;
        }
      }
    }
    return __typeCode;
  }

  public static String id ()
  {
    return _id;
  }

  public static sensei.middleware.gmns.GroupHandlerFactoryCreator read (org.omg.CORBA.portable.InputStream istream)
  {
    return (sensei.middleware.gmns.GroupHandlerFactoryCreator)((org.omg.CORBA_2_3.portable.InputStream) istream).read_value (id ());
  }

  public static void write (org.omg.CORBA.portable.OutputStream ostream, sensei.middleware.gmns.GroupHandlerFactoryCreator value)
  {
    ((org.omg.CORBA_2_3.portable.OutputStream) ostream).write_value (value, id ());
  }


}
