package sensei.middleware.gmns;


/**
* sensei/middleware/gmns/GroupMembershipBasicServiceOperations.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:18:51 PM CET
*/


/**
        * this interface allows the creation of new groups and the
        * extension of those groups by adding new members.
        * This service works on GroupMember basis: the service user wanting
        * to join a group must suply a member of that group
        **/
public interface GroupMembershipBasicServiceOperations 
{

  /**
            * Creates a GroupHandlerFactoryCreator
            **/
  sensei.middleware.gmns.GroupHandlerFactoryCreator getFactoryCreator ();

  /**
            * Creates a new group.
            * @param factory A factory creating GroupHandlers on demand
            **/
  sensei.middleware.gms.GroupHandler createGroup (sensei.middleware.gmns.GroupHandlerFactory theFactory) throws sensei.middleware.gmns.InvalidGroupHandlerFactoryException, sensei.middleware.gmns.GroupHandlerFactoryException;

  /**
            * Extends a group with an additional member
            * @param group a valid handler on a existing group.
            * @returns the group handler created, which can be nil if the member
            *    could not join the group because was considered faulty or because
            *    the groupHandler used is not valid or has been expulsed from the group
            **/
  sensei.middleware.gms.GroupHandler joinGroup (sensei.middleware.gms.GroupHandler group, sensei.middleware.gmns.GroupHandlerFactory theFactory) throws sensei.middleware.gmns.InvalidGroupHandlerException, sensei.middleware.gmns.InvalidGroupHandlerFactoryException, sensei.middleware.gmns.GroupHandlerFactoryException;
} // interface GroupMembershipBasicServiceOperations
