package sensei.middleware.gmns;


/**
* sensei/middleware/gmns/GroupMembershipBasicServicePOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:18:51 PM CET
*/


/**
        * this interface allows the creation of new groups and the
        * extension of those groups by adding new members.
        * This service works on GroupMember basis: the service user wanting
        * to join a group must suply a member of that group
        **/
public class GroupMembershipBasicServicePOATie extends GroupMembershipBasicServicePOA
{

  // Constructors

  public GroupMembershipBasicServicePOATie ( sensei.middleware.gmns.GroupMembershipBasicServiceOperations delegate ) {
      this._impl = delegate;
  }
  public GroupMembershipBasicServicePOATie ( sensei.middleware.gmns.GroupMembershipBasicServiceOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.gmns.GroupMembershipBasicServiceOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.gmns.GroupMembershipBasicServiceOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
            * Creates a GroupHandlerFactoryCreator
            **/
  public sensei.middleware.gmns.GroupHandlerFactoryCreator getFactoryCreator ()
  {
    return _impl.getFactoryCreator();
  } // getFactoryCreator


  /**
            * Creates a new group.
            * @param factory A factory creating GroupHandlers on demand
            **/
  public sensei.middleware.gms.GroupHandler createGroup (sensei.middleware.gmns.GroupHandlerFactory theFactory) throws sensei.middleware.gmns.InvalidGroupHandlerFactoryException, sensei.middleware.gmns.GroupHandlerFactoryException
  {
    return _impl.createGroup(theFactory);
  } // createGroup


  /**
            * Extends a group with an additional member
            * @param group a valid handler on a existing group.
            * @returns the group handler created, which can be nil if the member
            *    could not join the group because was considered faulty or because
            *    the groupHandler used is not valid or has been expulsed from the group
            **/
  public sensei.middleware.gms.GroupHandler joinGroup (sensei.middleware.gms.GroupHandler group, sensei.middleware.gmns.GroupHandlerFactory theFactory) throws sensei.middleware.gmns.InvalidGroupHandlerException, sensei.middleware.gmns.InvalidGroupHandlerFactoryException, sensei.middleware.gmns.GroupHandlerFactoryException
  {
    return _impl.joinGroup(group, theFactory);
  } // joinGroup

  private sensei.middleware.gmns.GroupMembershipBasicServiceOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class GroupMembershipBasicServicePOATie
