package sensei.middleware.gms;


/**
* sensei/middleware/gms/GroupHandlerPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:19:19 PM CET
*/


/**
        * GroupHandler defines the interface that allows to the application to
        * make group communications.
        */
public abstract class GroupHandlerPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.gms.GroupHandlerOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("getGroupMemberId", new java.lang.Integer (0));
    _methods.put ("isValidGroup", new java.lang.Integer (1));
    _methods.put ("leaveGroup", new java.lang.Integer (2));
    _methods.put ("castMessage", new java.lang.Integer (3));
    _methods.put ("sendMessage", new java.lang.Integer (4));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
            * Returns the GroupMemberId handled by this GroupHandler
            * If the member is not active, the returned value is random - negative.
            **/
       case 0:  // sensei/middleware/gms/GroupHandler/getGroupMemberId
       {
         int $result = (int)0;
         $result = this.getGroupMemberId ();
         out = $rh.createReply();
         out.write_long ($result);
         break;
       }


  /**
            * Returns true if the member belong to a group
            **/
       case 1:  // sensei/middleware/gms/GroupHandler/isValidGroup
       {
         boolean $result = false;
         $result = this.isValidGroup ();
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Leaves the group
            * @returns true if the member was belonging to a group
            **/
       case 2:  // sensei/middleware/gms/GroupHandler/leaveGroup
       {
         boolean $result = false;
         $result = this.leaveGroup ();
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Sends a message to every member in the view, returning
            * true if the message is sent on this view
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
       case 3:  // sensei/middleware/gms/GroupHandler/castMessage
       {
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         boolean $result = false;
         $result = this.castMessage (msg);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
            * Sends a message to the specified member in the view, returning
            * true if the message is sent on this view. This call allows
            * to keep the order between cast and point-to-point messages
            * @param target The member receiving the message
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
       case 4:  // sensei/middleware/gms/GroupHandler/sendMessage
       {
         int target = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         boolean $result = false;
         $result = this.sendMessage (target, msg);
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/gms/GroupHandler:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public GroupHandler _this() 
  {
    return GroupHandlerHelper.narrow(
    super._this_object());
  }

  public GroupHandler _this(org.omg.CORBA.ORB orb) 
  {
    return GroupHandlerHelper.narrow(
    super._this_object(orb));
  }


} // class GroupHandlerPOA
