package sensei.middleware.gms;


/**
* sensei/middleware/gms/GroupHandlerPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:19:19 PM CET
*/


/**
        * GroupHandler defines the interface that allows to the application to
        * make group communications.
        */
public class GroupHandlerPOATie extends GroupHandlerPOA
{

  // Constructors

  public GroupHandlerPOATie ( sensei.middleware.gms.GroupHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public GroupHandlerPOATie ( sensei.middleware.gms.GroupHandlerOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.gms.GroupHandlerOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.gms.GroupHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
            * Returns the GroupMemberId handled by this GroupHandler
            * If the member is not active, the returned value is random - negative.
            **/
  public int getGroupMemberId ()
  {
    return _impl.getGroupMemberId();
  } // getGroupMemberId


  /**
            * Returns true if the member belong to a group
            **/
  public boolean isValidGroup ()
  {
    return _impl.isValidGroup();
  } // isValidGroup


  /**
            * Leaves the group
            * @returns true if the member was belonging to a group
            **/
  public boolean leaveGroup ()
  {
    return _impl.leaveGroup();
  } // leaveGroup


  /**
            * Sends a message to every member in the view, returning
            * true if the message is sent on this view
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  public boolean castMessage (sensei.middleware.gms.Message msg)
  {
    return _impl.castMessage(msg);
  } // castMessage


  /**
            * Sends a message to the specified member in the view, returning
            * true if the message is sent on this view. This call allows
            * to keep the order between cast and point-to-point messages
            * @param target The member receiving the message
            * @param message The message to send
            * @returns true if the message is sent on the current view
            **/
  public boolean sendMessage (int target, sensei.middleware.gms.Message msg)
  {
    return _impl.sendMessage(target, msg);
  } // sendMessage

  private sensei.middleware.gms.GroupHandlerOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class GroupHandlerPOATie
