package sensei.middleware.gms;


/**
* sensei/middleware/gms/GroupMemberPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:19:19 PM CET
*/


/**
        * GroupMember specifies the interface to be implemented by group members
        */
public abstract class GroupMemberPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.gms.GroupMemberOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("processPTPMessage", new java.lang.Integer (0));
    _methods.put ("processCastMessage", new java.lang.Integer (1));
    _methods.put ("memberAccepted", new java.lang.Integer (2));
    _methods.put ("changingView", new java.lang.Integer (3));
    _methods.put ("installView", new java.lang.Integer (4));
    _methods.put ("excludedFromGroup", new java.lang.Integer (5));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
       case 0:  // sensei/middleware/gms/GroupMember/processPTPMessage
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         this.processPTPMessage (sender, msg);
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
       case 1:  // sensei/middleware/gms/GroupMember/processCastMessage
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         this.processCastMessage (sender, msg);
         out = $rh.createReply();
         break;
       }


  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
       case 2:  // sensei/middleware/gms/GroupMember/memberAccepted
       {
         int identity = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.GroupHandler handler = sensei.middleware.gms.GroupHandlerHelper.read (in);
         sensei.middleware.gms.View theView = sensei.middleware.gms.ViewHelper.read (in);
         this.memberAccepted (identity, handler, theView);
         out = $rh.createReply();
         break;
       }


  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
       case 3:  // sensei/middleware/gms/GroupMember/changingView
       {
         this.changingView ();
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
       case 4:  // sensei/middleware/gms/GroupMember/installView
       {
         sensei.middleware.gms.View theView = sensei.middleware.gms.ViewHelper.read (in);
         this.installView (theView);
         out = $rh.createReply();
         break;
       }


  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
       case 5:  // sensei/middleware/gms/GroupMember/excludedFromGroup
       {
         this.excludedFromGroup ();
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/gms/GroupMember:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public GroupMember _this() 
  {
    return GroupMemberHelper.narrow(
    super._this_object());
  }

  public GroupMember _this(org.omg.CORBA.ORB orb) 
  {
    return GroupMemberHelper.narrow(
    super._this_object(orb));
  }


} // class GroupMemberPOA
