package sensei.middleware.gms;


/**
* sensei/middleware/gms/GroupMemberPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:19:19 PM CET
*/


/**
        * GroupMember specifies the interface to be implemented by group members
        */
public class GroupMemberPOATie extends GroupMemberPOA
{

  // Constructors

  public GroupMemberPOATie ( sensei.middleware.gms.GroupMemberOperations delegate ) {
      this._impl = delegate;
  }
  public GroupMemberPOATie ( sensei.middleware.gms.GroupMemberOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.gms.GroupMemberOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.gms.GroupMemberOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
  public void processPTPMessage (int sender, sensei.middleware.gms.Message msg)
  {
    _impl.processPTPMessage(sender, msg);
  } // processPTPMessage


  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
  public void processCastMessage (int sender, sensei.middleware.gms.Message msg)
  {
    _impl.processCastMessage(sender, msg);
  } // processCastMessage


  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
  public void memberAccepted (int identity, sensei.middleware.gms.GroupHandler handler, sensei.middleware.gms.View theView)
  {
    _impl.memberAccepted(identity, handler, theView);
  } // memberAccepted


  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
  public void changingView ()
  {
    _impl.changingView();
  } // changingView


  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
  public void installView (sensei.middleware.gms.View theView)
  {
    _impl.installView(theView);
  } // installView


  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
  public void excludedFromGroup ()
  {
    _impl.excludedFromGroup();
  } // excludedFromGroup

  private sensei.middleware.gms.GroupMemberOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class GroupMemberPOATie
