package sensei.middleware.gms;


/**
* sensei/middleware/gms/_GroupMemberStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:19:19 PM CET
*/


/**
        * GroupMember specifies the interface to be implemented by group members
        */
public class _GroupMemberStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.gms.GroupMember
{


  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
  public void processPTPMessage (int sender, sensei.middleware.gms.Message msg)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("processPTPMessage", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.MessageHelper.write ($out, msg);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                processPTPMessage (sender, msg        );
            } finally {
                _releaseReply ($in);
            }
  } // processPTPMessage


  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
  public void processCastMessage (int sender, sensei.middleware.gms.Message msg)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("processCastMessage", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, sender);
                sensei.middleware.gms.MessageHelper.write ($out, msg);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                processCastMessage (sender, msg        );
            } finally {
                _releaseReply ($in);
            }
  } // processCastMessage


  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
  public void memberAccepted (int identity, sensei.middleware.gms.GroupHandler handler, sensei.middleware.gms.View theView)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("memberAccepted", true);
                sensei.middleware.gms.GroupMemberIdHelper.write ($out, identity);
                sensei.middleware.gms.GroupHandlerHelper.write ($out, handler);
                sensei.middleware.gms.ViewHelper.write ($out, theView);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                memberAccepted (identity, handler, theView        );
            } finally {
                _releaseReply ($in);
            }
  } // memberAccepted


  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
  public void changingView ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("changingView", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                changingView (        );
            } finally {
                _releaseReply ($in);
            }
  } // changingView


  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
  public void installView (sensei.middleware.gms.View theView)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("installView", true);
                sensei.middleware.gms.ViewHelper.write ($out, theView);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                installView (theView        );
            } finally {
                _releaseReply ($in);
            }
  } // installView


  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
  public void excludedFromGroup ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("excludedFromGroup", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                excludedFromGroup (        );
            } finally {
                _releaseReply ($in);
            }
  } // excludedFromGroup

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/gms/GroupMember:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _GroupMemberStub
