/**
  * File: GMNSRegister.java
  * Content: Class to register the valuetypes on the ORB. In RMI case, does nothing (still the main !)
  * Author: LuisM Pena
  * Date: 		1st December 2001
  * Version:  0.29.00
  * Last change:
  *
  **/

package sensei.middleware.gmns;

/**
  * Class to register the valuetypes on the ORB
  **/
public abstract class GMNSRegisterBase {
	//*************************************************************************************
	//**************************** ORB REGISTERING ****************************************
	//*************************************************************************************

	public GMNSRegisterBase(GMNSMain mainClass, String args[], boolean graphicalMode) {
		mainClass.runGMNS(graphicalMode);
	}

	protected abstract GroupHandlerFactoryCreator createGroupHandlerFactoryCreator();

}
