/**
  * File: 		MemberInfo.java
  * Content: 	part of the RMI specification of sensei gmns
  * Author: 	LuisM Pena
  * Date: 		1st December 2001
  * Version:  0.29.00
  * Last change:
  *
  **/


package sensei.middleware.gmns;

import sensei.middleware.gms.GroupHandler;

final public class MemberInfo implements java.io.Serializable
{
    public
    MemberInfo()
    {
    }

    public
    MemberInfo(GroupHandler handler,
               String name,
               ReplicatedServer publicReference)
    {
        this.handler = handler;
        this.name = name;
        this.publicReference = publicReference;
    }

    public GroupHandler handler;
    public String name;
    public ReplicatedServer publicReference;
}
