/**
  * File: GMNSAutoObserver.java
  * Content: Interface to receive events about the own GMNS group
  * Author: LuisM Pena
  * Date: 5th December 2000
  * Version: 0.29.00
  * Last change:
  *
  **/

package sensei.gmns;

public interface GMNSAutoObserver {
	public void joined(int replicas);
	public void changedReplicaNumber(int replicas);
	public void excluded();
	public void receivingState();
	public void readingStateFromBackup();
	public void stateReceived(PersistenceHandler handler);

	public void message(String s);
}
