package senseiTests.domainsTest;

import sensei.util.ParameterException;
import sensei.util.Parameters;
import senseiTests.domainsTest.middleware.MiddlewareInitialitation;

public class Main {
	public static void main(String args[]) throws Exception {
		try {
			Parameters parameters = Tester.readArgs(args);
			if (parameters != null) {
				Runnable realMain = new Tester(parameters);
				MiddlewareInitialitation.init(realMain, args);
			}
		}
		catch (ParameterException pex) {
			System.out.println(pex);
		}
	}
}
