package sensei.middleware.domains;


/**
* sensei/middleware/domains/BasicStateHandlerPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/***********************************************************************/
public abstract class BasicStateHandlerPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.domains.BasicStateHandlerOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("assumeState", new java.lang.Integer (0));
    _methods.put ("startTransfer", new java.lang.Integer (1));
    _methods.put ("getState", new java.lang.Integer (2));
    _methods.put ("setState", new java.lang.Integer (3));
    _methods.put ("stopTransfer", new java.lang.Integer (4));
    _methods.put ("processPTPMessage", new java.lang.Integer (5));
    _methods.put ("processCastMessage", new java.lang.Integer (6));
    _methods.put ("memberAccepted", new java.lang.Integer (7));
    _methods.put ("changingView", new java.lang.Integer (8));
    _methods.put ("installView", new java.lang.Integer (9));
    _methods.put ("excludedFromGroup", new java.lang.Integer (10));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {
       case 0:  // sensei/middleware/domains/BasicStateHandler/assumeState
       {
         this.assumeState ();
         out = $rh.createReply();
         break;
       }

       case 1:  // sensei/middleware/domains/BasicStateHandler/startTransfer
       {
         int joiningMembers[] = sensei.middleware.domains.LocationsHelper.read (in);
         sensei.middleware.domains.PhaseCoordinationHolder phase = new sensei.middleware.domains.PhaseCoordinationHolder ();
         phase.value = sensei.middleware.domains.PhaseCoordinationHelper.read (in);
         this.startTransfer (joiningMembers, phase);
         out = $rh.createReply();
         sensei.middleware.domains.PhaseCoordinationHelper.write (out, phase.value);
         break;
       }

       case 2:  // sensei/middleware/domains/BasicStateHandler/getState
       {
         sensei.middleware.domains.PhaseCoordinationHolder phase = new sensei.middleware.domains.PhaseCoordinationHolder ();
         phase.value = sensei.middleware.domains.PhaseCoordinationHelper.read (in);
         sensei.middleware.domains.State $result = null;
         $result = this.getState (phase);
         out = $rh.createReply();
         sensei.middleware.domains.StateHelper.write (out, $result);
         sensei.middleware.domains.PhaseCoordinationHelper.write (out, phase.value);
         break;
       }

       case 3:  // sensei/middleware/domains/BasicStateHandler/setState
       {
         sensei.middleware.domains.State s = sensei.middleware.domains.StateHelper.read (in);
         sensei.middleware.domains.PhaseCoordination phase = sensei.middleware.domains.PhaseCoordinationHelper.read (in);
         this.setState (s, phase);
         out = $rh.createReply();
         break;
       }

       case 4:  // sensei/middleware/domains/BasicStateHandler/stopTransfer
       {
         int joiningMembers[] = sensei.middleware.domains.LocationsHelper.read (in);
         boolean transferFinished = in.read_boolean ();
         this.stopTransfer (joiningMembers, transferFinished);
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a point to point message to be processed
            * @param message The message to process
            **/
       case 5:  // sensei/middleware/gms/GroupMember/processPTPMessage
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         this.processPTPMessage (sender, msg);
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a group message to be processed
            * @param message The message to process
            **/
       case 6:  // sensei/middleware/gms/GroupMember/processCastMessage
       {
         int sender = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.Message msg = sensei.middleware.gms.MessageHelper.read (in);
         this.processCastMessage (sender, msg);
         out = $rh.createReply();
         break;
       }


  /**
            * The member is accepted in the group, and receives its identity and the
            *  first view. It receives as well the group handler to use for communications
            **/
       case 7:  // sensei/middleware/gms/GroupMember/memberAccepted
       {
         int identity = sensei.middleware.gms.GroupMemberIdHelper.read (in);
         sensei.middleware.gms.GroupHandler handler = sensei.middleware.gms.GroupHandlerHelper.read (in);
         sensei.middleware.gms.View theView = sensei.middleware.gms.ViewHelper.read (in);
         this.memberAccepted (identity, handler, theView);
         out = $rh.createReply();
         break;
       }


  /**
            * The group is going to change the view, any new message will be sent on the next view
            **/
       case 8:  // sensei/middleware/gms/GroupMember/changingView
       {
         this.changingView ();
         out = $rh.createReply();
         break;
       }


  /**
            * The member receives a new view, including the list of members
            * @param message The message to process
            **/
       case 9:  // sensei/middleware/gms/GroupMember/installView
       {
         sensei.middleware.gms.View theView = sensei.middleware.gms.ViewHelper.read (in);
         this.installView (theView);
         out = $rh.createReply();
         break;
       }


  /**
            * The member is excluded from the group, because it has requested it or because
            * it's considered to be faulty.
            **/
       case 10:  // sensei/middleware/gms/GroupMember/excludedFromGroup
       {
         this.excludedFromGroup ();
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/BasicStateHandler:1.0", 
    "IDL:sensei/middleware/gms/GroupMember:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public BasicStateHandler _this() 
  {
    return BasicStateHandlerHelper.narrow(
    super._this_object());
  }

  public BasicStateHandler _this(org.omg.CORBA.ORB orb) 
  {
    return BasicStateHandlerHelper.narrow(
    super._this_object(orb));
  }


} // class BasicStateHandlerPOA
