package sensei.middleware.domains;

/**
* sensei/middleware/domains/DomainGroupHandlerHolder.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
        * GroupMember targetted as central instance to handle several subgroups
        * Messages sent through this class must belong to the DomainMessage hierarchy
        *
        *   -	It allows to define several subgroups to be handled separately by one group.
        *   - The subgroups can be created/removed dynamically.
        *   -	It includes the abstraction group/subgroups or domain/groups
        * It supports several special features:
        * -The sending of messages blocks the caller until the message is received
        * -Reception of cast messages sent by the own member are not propagated to the
        *    subgroups: they just unblock the message sending.
        * -PTP messages can be sent to all the subgroups in the group
        * -State transfer support
        * -Replica properties support
        * -Transactions support
        **/
public final class DomainGroupHandlerHolder implements org.omg.CORBA.portable.Streamable
{
  public sensei.middleware.domains.DomainGroupHandler value = null;

  public DomainGroupHandlerHolder ()
  {
  }

  public DomainGroupHandlerHolder (sensei.middleware.domains.DomainGroupHandler initialValue)
  {
    value = initialValue;
  }

  public void _read (org.omg.CORBA.portable.InputStream i)
  {
    value = sensei.middleware.domains.DomainGroupHandlerHelper.read (i);
  }

  public void _write (org.omg.CORBA.portable.OutputStream o)
  {
    sensei.middleware.domains.DomainGroupHandlerHelper.write (o, value);
  }

  public org.omg.CORBA.TypeCode _type ()
  {
    return sensei.middleware.domains.DomainGroupHandlerHelper.type ();
  }

}
