package sensei.middleware.domains;


/**
* sensei/middleware/domains/DomainGroupUserPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
       * Interface to be implemented optionally by members using domains
       */
public abstract class DomainGroupUserPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.domains.DomainGroupUserOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("domainAccepted", new java.lang.Integer (0));
    _methods.put ("domainExpulsed", new java.lang.Integer (1));
    _methods.put ("stateObtained", new java.lang.Integer (2));
    _methods.put ("offendingSubgroup", new java.lang.Integer (3));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
           * Invoked when the DomainGroup is accepted into its subgroup
           */
       case 0:  // sensei/middleware/domains/DomainGroupUser/domainAccepted
       {
         int id = sensei.middleware.domains.GroupMemberIdHelper.read (in);
         this.domainAccepted (id);
         out = $rh.createReply();
         break;
       }


  /**
           * Invoked when the DomainGroup is expulsed from its subgroup
           */
       case 1:  // sensei/middleware/domains/DomainGroupUser/domainExpulsed
       {
         sensei.middleware.domains.DomainExpulsionReason reason = sensei.middleware.domains.DomainExpulsionReasonHelper.read (in);
         this.domainExpulsed (reason);
         out = $rh.createReply();
         break;
       }


  /**
           * Invoked when the DomainGroup is considered to have state
           * @param assumed set to true if this member is assuming state, i.e, is not transfered
           */
       case 2:  // sensei/middleware/domains/DomainGroupUser/stateObtained
       {
         boolean assumed = in.read_boolean ();
         this.stateObtained (assumed);
         out = $rh.createReply();
         break;
       }


  /**
           * Invoked when the a subgroup in the domain is not reachable. This
           * call will be followed by a domainExpulsed call eventually.
           * @param subgroupId the identity of the subgroup causing the problem
           * @param reason an string explaining the problem
           */
       case 3:  // sensei/middleware/domains/DomainGroupUser/offendingSubgroup
       {
         int subgroup = sensei.middleware.domains.SubgroupIdHelper.read (in);
         String reason = in.read_string ();
         this.offendingSubgroup (subgroup, reason);
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/DomainGroupUser:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public DomainGroupUser _this() 
  {
    return DomainGroupUserHelper.narrow(
    super._this_object());
  }

  public DomainGroupUser _this(org.omg.CORBA.ORB orb) 
  {
    return DomainGroupUserHelper.narrow(
    super._this_object(orb));
  }


} // class DomainGroupUserPOA
