package sensei.middleware.domains;


/**
* sensei/middleware/domains/DomainGroupUserPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
       * Interface to be implemented optionally by members using domains
       */
public class DomainGroupUserPOATie extends DomainGroupUserPOA
{

  // Constructors

  public DomainGroupUserPOATie ( sensei.middleware.domains.DomainGroupUserOperations delegate ) {
      this._impl = delegate;
  }
  public DomainGroupUserPOATie ( sensei.middleware.domains.DomainGroupUserOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.domains.DomainGroupUserOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.domains.DomainGroupUserOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
           * Invoked when the DomainGroup is accepted into its subgroup
           */
  public void domainAccepted (int id)
  {
    _impl.domainAccepted(id);
  } // domainAccepted


  /**
           * Invoked when the DomainGroup is expulsed from its subgroup
           */
  public void domainExpulsed (sensei.middleware.domains.DomainExpulsionReason reason)
  {
    _impl.domainExpulsed(reason);
  } // domainExpulsed


  /**
           * Invoked when the DomainGroup is considered to have state
           * @param assumed set to true if this member is assuming state, i.e, is not transfered
           */
  public void stateObtained (boolean assumed)
  {
    _impl.stateObtained(assumed);
  } // stateObtained


  /**
           * Invoked when the a subgroup in the domain is not reachable. This
           * call will be followed by a domainExpulsed call eventually.
           * @param subgroupId the identity of the subgroup causing the problem
           * @param reason an string explaining the problem
           */
  public void offendingSubgroup (int subgroup, String reason)
  {
    _impl.offendingSubgroup(subgroup, reason);
  } // offendingSubgroup

  private sensei.middleware.domains.DomainGroupUserOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class DomainGroupUserPOATie
