package sensei.middleware.domains;


/**
* sensei/middleware/domains/DynamicSubgroupsUserPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/**
       * Defines the interface to be used by members using the SubgroupsHandler interface
       * with dynamic groups
       */
public abstract class DynamicSubgroupsUserPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.domains.DynamicSubgroupsUserOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("acceptSubgroup", new java.lang.Integer (0));
    _methods.put ("subgroupCreated", new java.lang.Integer (1));
    _methods.put ("subgroupRemoved", new java.lang.Integer (2));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
           * Request during state transfer to accept an existing dynamic subgroup; a subgroup must be returned,
           */
       case 0:  // sensei/middleware/domains/DynamicSubgroupsUser/acceptSubgroup
       {
         int id = sensei.middleware.domains.SubgroupIdHelper.read (in);
         sensei.middleware.domains.DynamicSubgroupInfo info = sensei.middleware.domains.DynamicSubgroupInfoHelper.read (in);
         sensei.middleware.gms.GroupMember $result = null;
         $result = this.acceptSubgroup (id, info);
         out = $rh.createReply();
         sensei.middleware.gms.GroupMemberHelper.write (out, $result);
         break;
       }


  /**
           * Notification that a subgroup has been dynamically created. A subgroup must be returned,
           */
       case 1:  // sensei/middleware/domains/DynamicSubgroupsUser/subgroupCreated
       {
         int creator = sensei.middleware.domains.GroupMemberIdHelper.read (in);
         int id = sensei.middleware.domains.SubgroupIdHelper.read (in);
         sensei.middleware.domains.DynamicSubgroupInfo info = sensei.middleware.domains.DynamicSubgroupInfoHelper.read (in);
         sensei.middleware.gms.GroupMember $result = null;
         $result = this.subgroupCreated (creator, id, info);
         out = $rh.createReply();
         sensei.middleware.gms.GroupMemberHelper.write (out, $result);
         break;
       }


  /**
           * Notification that a subgroup has been dynamically removed.
           */
       case 2:  // sensei/middleware/domains/DynamicSubgroupsUser/subgroupRemoved
       {
         int remover = sensei.middleware.domains.GroupMemberIdHelper.read (in);
         int id = sensei.middleware.domains.SubgroupIdHelper.read (in);
         sensei.middleware.domains.DynamicSubgroupInfo info = sensei.middleware.domains.DynamicSubgroupInfoHelper.read (in);
         this.subgroupRemoved (remover, id, info);
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/DynamicSubgroupsUser:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public DynamicSubgroupsUser _this() 
  {
    return DynamicSubgroupsUserHelper.narrow(
    super._this_object());
  }

  public DynamicSubgroupsUser _this(org.omg.CORBA.ORB orb) 
  {
    return DynamicSubgroupsUserHelper.narrow(
    super._this_object(orb));
  }


} // class DynamicSubgroupsUserPOA
