package sensei.middleware.domains;


/**
* sensei/middleware/domains/DynamicSubgroupsUserPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/**
       * Defines the interface to be used by members using the SubgroupsHandler interface
       * with dynamic groups
       */
public class DynamicSubgroupsUserPOATie extends DynamicSubgroupsUserPOA
{

  // Constructors

  public DynamicSubgroupsUserPOATie ( sensei.middleware.domains.DynamicSubgroupsUserOperations delegate ) {
      this._impl = delegate;
  }
  public DynamicSubgroupsUserPOATie ( sensei.middleware.domains.DynamicSubgroupsUserOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.domains.DynamicSubgroupsUserOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.domains.DynamicSubgroupsUserOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
           * Request during state transfer to accept an existing dynamic subgroup; a subgroup must be returned,
           */
  public sensei.middleware.gms.GroupMember acceptSubgroup (int id, sensei.middleware.domains.DynamicSubgroupInfo info)
  {
    return _impl.acceptSubgroup(id, info);
  } // acceptSubgroup


  /**
           * Notification that a subgroup has been dynamically created. A subgroup must be returned,
           */
  public sensei.middleware.gms.GroupMember subgroupCreated (int creator, int id, sensei.middleware.domains.DynamicSubgroupInfo info)
  {
    return _impl.subgroupCreated(creator, id, info);
  } // subgroupCreated


  /**
           * Notification that a subgroup has been dynamically removed.
           */
  public void subgroupRemoved (int remover, int id, sensei.middleware.domains.DynamicSubgroupInfo info)
  {
    _impl.subgroupRemoved(remover, id, info);
  } // subgroupRemoved

  private sensei.middleware.domains.DynamicSubgroupsUserOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class DynamicSubgroupsUserPOATie
