package sensei.middleware.domains;


/**
* sensei/middleware/domains/PropertiesHandlerPOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/***********************************************************************/
public abstract class PropertiesHandlerPOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.domains.PropertiesHandlerOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("enableProperties", new java.lang.Integer (0));
    _methods.put ("arePropertiesEnabled", new java.lang.Integer (1));
    _methods.put ("setPropertiesListener", new java.lang.Integer (2));
    _methods.put ("getAllProperties", new java.lang.Integer (3));
    _methods.put ("getPropertyForAllMembers", new java.lang.Integer (4));
    _methods.put ("getMemberProperties", new java.lang.Integer (5));
    _methods.put ("getMemberProperty", new java.lang.Integer (6));
    _methods.put ("getProperties", new java.lang.Integer (7));
    _methods.put ("getProperty", new java.lang.Integer (8));
    _methods.put ("setProperties", new java.lang.Integer (9));
    _methods.put ("addProperties", new java.lang.Integer (10));
    _methods.put ("removeProperties", new java.lang.Integer (11));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
           * Enables the use of properties, which is disabled by default.
           * This method must be invoked before the member joins the group, or an exception is raised.
           * Every member in the group must use the same properties
           * policy.
           */
       case 0:  // sensei/middleware/domains/PropertiesHandler/enableProperties
       {
         try {
           this.enableProperties ();
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the properties policy
           */
       case 1:  // sensei/middleware/domains/PropertiesHandler/arePropertiesEnabled
       {
         boolean $result = false;
         $result = this.arePropertiesEnabled ();
         out = $rh.createReply();
         out.write_boolean ($result);
         break;
       }


  /**
           * Sets a PropertiesListener, that will receive the properties update notifications. The user
           * can be set at any moment, and if a nil user is specified, no user will be used.
           */
       case 2:  // sensei/middleware/domains/PropertiesHandler/setPropertiesListener
       {
         try {
           sensei.middleware.domains.PropertiesListener listener = sensei.middleware.domains.PropertiesListenerHelper.read (in);
           this.setPropertiesListener (listener);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the properties of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
       case 3:  // sensei/middleware/domains/PropertiesHandler/getAllProperties
       {
         try {
           sensei.middleware.domains.MemberProperties $result[] = null;
           $result = this.getAllProperties ();
           out = $rh.createReply();
           sensei.middleware.domains.MemberPropertiesListHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the property with the given name of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
       case 4:  // sensei/middleware/domains/PropertiesHandler/getPropertyForAllMembers
       {
         try {
           String nam = sensei.middleware.domains.NameHelper.read (in);
           sensei.middleware.domains.MemberProperties $result[] = null;
           $result = this.getPropertyForAllMembers (nam);
           out = $rh.createReply();
           sensei.middleware.domains.MemberPropertiesListHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the properties of the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
       case 5:  // sensei/middleware/domains/PropertiesHandler/getMemberProperties
       {
         try {
           int loc = sensei.middleware.domains.LocationHelper.read (in);
           sensei.middleware.domains.Property $result[] = null;
           $result = this.getMemberProperties (loc);
           out = $rh.createReply();
           sensei.middleware.domains.PropertiesHelper.write (out, $result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the property with the given name for the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
       case 6:  // sensei/middleware/domains/PropertiesHandler/getMemberProperty
       {
         try {
           int loc = sensei.middleware.domains.LocationHelper.read (in);
           String n = sensei.middleware.domains.NameHelper.read (in);
           String $result = null;
           $result = this.getMemberProperty (loc, n);
           out = $rh.createReply();
           out.write_string ($result);
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the properties of the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
       case 7:  // sensei/middleware/domains/PropertiesHandler/getProperties
       {
         try {
           sensei.middleware.domains.Property $result[] = null;
           $result = this.getProperties ();
           out = $rh.createReply();
           sensei.middleware.domains.PropertiesHelper.write (out, $result);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Returns the property with the given name for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
       case 8:  // sensei/middleware/domains/PropertiesHandler/getProperty
       {
         try {
           String n = sensei.middleware.domains.NameHelper.read (in);
           String $result = null;
           $result = this.getProperty (n);
           out = $rh.createReply();
           out.write_string ($result);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Sets the properties for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
       case 9:  // sensei/middleware/domains/PropertiesHandler/setProperties
       {
         try {
           sensei.middleware.domains.Property props[] = sensei.middleware.domains.PropertiesHelper.read (in);
           this.setProperties (props);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Adds the properties for the member handled by this PropertyHandler. If some property were already
           * existing, its value is overriden.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
       case 10:  // sensei/middleware/domains/PropertiesHandler/addProperties
       {
         try {
           sensei.middleware.domains.Property props[] = sensei.middleware.domains.PropertiesHelper.read (in);
           this.addProperties (props);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
           * Removes the properties for the member handled by this PropertyHandler. If some property were not
           * existing, it is ignored.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
       case 11:  // sensei/middleware/domains/PropertiesHandler/removeProperties
       {
         try {
           sensei.middleware.domains.Property props[] = sensei.middleware.domains.PropertiesHelper.read (in);
           this.removeProperties (props);
           out = $rh.createReply();
         } catch (sensei.middleware.domains.MemberStateException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.MemberStateExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.domains.PropertiesDisabledException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.domains.PropertiesDisabledExceptionHelper.write (out, $ex);
         }
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/PropertiesHandler:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public PropertiesHandler _this() 
  {
    return PropertiesHandlerHelper.narrow(
    super._this_object());
  }

  public PropertiesHandler _this(org.omg.CORBA.ORB orb) 
  {
    return PropertiesHandlerHelper.narrow(
    super._this_object(orb));
  }


} // class PropertiesHandlerPOA
