package sensei.middleware.domains;


/**
* sensei/middleware/domains/PropertiesHandlerPOATie.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/***********************************************************************/
public class PropertiesHandlerPOATie extends PropertiesHandlerPOA
{

  // Constructors

  public PropertiesHandlerPOATie ( sensei.middleware.domains.PropertiesHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public PropertiesHandlerPOATie ( sensei.middleware.domains.PropertiesHandlerOperations delegate , org.omg.PortableServer.POA poa ) {
      this._impl = delegate;
      this._poa      = poa;
  }
  public sensei.middleware.domains.PropertiesHandlerOperations _delegate() {
      return this._impl;
  }
  public void _delegate (sensei.middleware.domains.PropertiesHandlerOperations delegate ) {
      this._impl = delegate;
  }
  public org.omg.PortableServer.POA _default_POA() {
      if(_poa != null) {
          return _poa;
      }
      else {
          return super._default_POA();
      }
  }

  /**
           * Enables the use of properties, which is disabled by default.
           * This method must be invoked before the member joins the group, or an exception is raised.
           * Every member in the group must use the same properties
           * policy.
           */
  public void enableProperties () throws sensei.middleware.domains.MemberStateException
  {
    _impl.enableProperties();
  } // enableProperties


  /**
           * Returns the properties policy
           */
  public boolean arePropertiesEnabled ()
  {
    return _impl.arePropertiesEnabled();
  } // arePropertiesEnabled


  /**
           * Sets a PropertiesListener, that will receive the properties update notifications. The user
           * can be set at any moment, and if a nil user is specified, no user will be used.
           */
  public void setPropertiesListener (sensei.middleware.domains.PropertiesListener listener) throws sensei.middleware.domains.PropertiesDisabledException
  {
    _impl.setPropertiesListener(listener);
  } // setPropertiesListener


  /**
           * Returns the properties of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.MemberProperties[] getAllProperties () throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getAllProperties();
  } // getAllProperties


  /**
           * Returns the property with the given name of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.MemberProperties[] getPropertyForAllMembers (String nam) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getPropertyForAllMembers(nam);
  } // getPropertyForAllMembers


  /**
           * Returns the properties of the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.Property[] getMemberProperties (int loc) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getMemberProperties(loc);
  } // getMemberProperties


  /**
           * Returns the property with the given name for the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public String getMemberProperty (int loc, String n) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getMemberProperty(loc, n);
  } // getMemberProperty


  /**
           * Returns the properties of the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
  public sensei.middleware.domains.Property[] getProperties () throws sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getProperties();
  } // getProperties


  /**
           * Returns the property with the given name for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
  public String getProperty (String n) throws sensei.middleware.domains.PropertiesDisabledException
  {
    return _impl.getProperty(n);
  } // getProperty


  /**
           * Sets the properties for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void setProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    _impl.setProperties(props);
  } // setProperties


  /**
           * Adds the properties for the member handled by this PropertyHandler. If some property were already
           * existing, its value is overriden.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void addProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    _impl.addProperties(props);
  } // addProperties


  /**
           * Removes the properties for the member handled by this PropertyHandler. If some property were not
           * existing, it is ignored.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void removeProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
    _impl.removeProperties(props);
  } // removeProperties

  private sensei.middleware.domains.PropertiesHandlerOperations _impl;
  private org.omg.PortableServer.POA _poa;

} // class PropertiesHandlerPOATie
