package sensei.middleware.domains;


/**
* sensei/middleware/domains/_DomainGroupUserStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:01 AM CET
*/


/**
       * Interface to be implemented optionally by members using domains
       */
public class _DomainGroupUserStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.domains.DomainGroupUser
{


  /**
           * Invoked when the DomainGroup is accepted into its subgroup
           */
  public void domainAccepted (int id)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("domainAccepted", true);
                sensei.middleware.domains.GroupMemberIdHelper.write ($out, id);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                domainAccepted (id        );
            } finally {
                _releaseReply ($in);
            }
  } // domainAccepted


  /**
           * Invoked when the DomainGroup is expulsed from its subgroup
           */
  public void domainExpulsed (sensei.middleware.domains.DomainExpulsionReason reason)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("domainExpulsed", true);
                sensei.middleware.domains.DomainExpulsionReasonHelper.write ($out, reason);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                domainExpulsed (reason        );
            } finally {
                _releaseReply ($in);
            }
  } // domainExpulsed


  /**
           * Invoked when the DomainGroup is considered to have state
           * @param assumed set to true if this member is assuming state, i.e, is not transfered
           */
  public void stateObtained (boolean assumed)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("stateObtained", true);
                $out.write_boolean (assumed);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                stateObtained (assumed        );
            } finally {
                _releaseReply ($in);
            }
  } // stateObtained


  /**
           * Invoked when the a subgroup in the domain is not reachable. This
           * call will be followed by a domainExpulsed call eventually.
           * @param subgroupId the identity of the subgroup causing the problem
           * @param reason an string explaining the problem
           */
  public void offendingSubgroup (int subgroup, String reason)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("offendingSubgroup", true);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, subgroup);
                $out.write_string (reason);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                offendingSubgroup (subgroup, reason        );
            } finally {
                _releaseReply ($in);
            }
  } // offendingSubgroup

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/DomainGroupUser:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _DomainGroupUserStub
