package sensei.middleware.domains;


/**
* sensei/middleware/domains/_PropertiesHandlerStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/***********************************************************************/
public class _PropertiesHandlerStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.domains.PropertiesHandler
{


  /**
           * Enables the use of properties, which is disabled by default.
           * This method must be invoked before the member joins the group, or an exception is raised.
           * Every member in the group must use the same properties
           * policy.
           */
  public void enableProperties () throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("enableProperties", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                enableProperties (        );
            } finally {
                _releaseReply ($in);
            }
  } // enableProperties


  /**
           * Returns the properties policy
           */
  public boolean arePropertiesEnabled ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("arePropertiesEnabled", true);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return arePropertiesEnabled (        );
            } finally {
                _releaseReply ($in);
            }
  } // arePropertiesEnabled


  /**
           * Sets a PropertiesListener, that will receive the properties update notifications. The user
           * can be set at any moment, and if a nil user is specified, no user will be used.
           */
  public void setPropertiesListener (sensei.middleware.domains.PropertiesListener listener) throws sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setPropertiesListener", true);
                sensei.middleware.domains.PropertiesListenerHelper.write ($out, listener);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setPropertiesListener (listener        );
            } finally {
                _releaseReply ($in);
            }
  } // setPropertiesListener


  /**
           * Returns the properties of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.MemberProperties[] getAllProperties () throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getAllProperties", true);
                $in = _invoke ($out);
                sensei.middleware.domains.MemberProperties $result[] = sensei.middleware.domains.MemberPropertiesListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getAllProperties (        );
            } finally {
                _releaseReply ($in);
            }
  } // getAllProperties


  /**
           * Returns the property with the given name of all the members with state.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.MemberProperties[] getPropertyForAllMembers (String nam) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getPropertyForAllMembers", true);
                sensei.middleware.domains.NameHelper.write ($out, nam);
                $in = _invoke ($out);
                sensei.middleware.domains.MemberProperties $result[] = sensei.middleware.domains.MemberPropertiesListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getPropertyForAllMembers (nam        );
            } finally {
                _releaseReply ($in);
            }
  } // getPropertyForAllMembers


  /**
           * Returns the properties of the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public sensei.middleware.domains.Property[] getMemberProperties (int loc) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getMemberProperties", true);
                sensei.middleware.domains.LocationHelper.write ($out, loc);
                $in = _invoke ($out);
                sensei.middleware.domains.Property $result[] = sensei.middleware.domains.PropertiesHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getMemberProperties (loc        );
            } finally {
                _releaseReply ($in);
            }
  } // getMemberProperties


  /**
           * Returns the property with the given name for the specified member.
           * Properties are only available once the member has received the state. Otherwise, an
           * MemberStateException is thrown
           */
  public String getMemberProperty (int loc, String n) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getMemberProperty", true);
                sensei.middleware.domains.LocationHelper.write ($out, loc);
                sensei.middleware.domains.NameHelper.write ($out, n);
                $in = _invoke ($out);
                String $result = sensei.middleware.domains.ValueHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getMemberProperty (loc, n        );
            } finally {
                _releaseReply ($in);
            }
  } // getMemberProperty


  /**
           * Returns the properties of the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
  public sensei.middleware.domains.Property[] getProperties () throws sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getProperties", true);
                $in = _invoke ($out);
                sensei.middleware.domains.Property $result[] = sensei.middleware.domains.PropertiesHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getProperties (        );
            } finally {
                _releaseReply ($in);
            }
  } // getProperties


  /**
           * Returns the property with the given name for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state
           */
  public String getProperty (String n) throws sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getProperty", true);
                sensei.middleware.domains.NameHelper.write ($out, n);
                $in = _invoke ($out);
                String $result = sensei.middleware.domains.ValueHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getProperty (n        );
            } finally {
                _releaseReply ($in);
            }
  } // getProperty


  /**
           * Sets the properties for the member handled by this PropertyHandler.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void setProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setProperties", true);
                sensei.middleware.domains.PropertiesHelper.write ($out, props);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setProperties (props        );
            } finally {
                _releaseReply ($in);
            }
  } // setProperties


  /**
           * Adds the properties for the member handled by this PropertyHandler. If some property were already
           * existing, its value is overriden.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void addProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("addProperties", true);
                sensei.middleware.domains.PropertiesHelper.write ($out, props);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                addProperties (props        );
            } finally {
                _releaseReply ($in);
            }
  } // addProperties


  /**
           * Removes the properties for the member handled by this PropertyHandler. If some property were not
           * existing, it is ignored.
           * Properties for a given member are available at any moment, not just after the member receives the state.
           * The properties are propagated to the group if the member has state, otherwise the other members will
           * know the changes once the transfer finishes.
           */
  public void removeProperties (sensei.middleware.domains.Property[] props) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.PropertiesDisabledException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("removeProperties", true);
                sensei.middleware.domains.PropertiesHelper.write ($out, props);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/PropertiesDisabledException:1.0"))
                    throw sensei.middleware.domains.PropertiesDisabledExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                removeProperties (props        );
            } finally {
                _releaseReply ($in);
            }
  } // removeProperties

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/PropertiesHandler:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _PropertiesHandlerStub
