package sensei.middleware.domains;


/**
* sensei/middleware/domains/_SubgroupsHandlerStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/


/**
       *  Interface supporting subgroups handling
       **/
public class _SubgroupsHandlerStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.domains.SubgroupsHandler
{


  /**
           * Sets a DynamicSubgroupsUser listener. This user must be set before the member joins
           * a group, or an exception is raised
           */
  public void setDynamicSubgroupsUser (sensei.middleware.domains.DynamicSubgroupsUser user) throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setDynamicSubgroupsUser", true);
                sensei.middleware.domains.DynamicSubgroupsUserHelper.write ($out, user);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setDynamicSubgroupsUser (user        );
            } finally {
                _releaseReply ($in);
            }
  } // setDynamicSubgroupsUser


  /**
            * Registers a static subgroup with a specific ID. This ID must be unique in the object and also
            * in the group. The group cannot have been activated yet, or an exception is raised.
            * Every member must have defined the same subgroups when the group is joined.
            * Once joined, it is not possible anymore to use registerSubgroup, as the subgroups
            * must be dynamically registered.
            * The subgroups registered with this method cannot be later unregistered.
            * The subgroupId must be a valid static subgroup Id (lower or equal to MAX_STATIC_SUBGROUP_ID)
            * or the subgroup is not registered and an exception is raised
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the subgroupId specified is not valid (not static)
            **/
  public void registerSubgroup (int uniqueSubgroupId, sensei.middleware.gms.GroupMember subgroup) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("registerSubgroup", true);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, uniqueSubgroupId);
                sensei.middleware.domains.GroupMemberHelper.write ($out, subgroup);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/SubgroupsHandlerException:1.0"))
                    throw sensei.middleware.domains.SubgroupsHandlerExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                registerSubgroup (uniqueSubgroupId, subgroup        );
            } finally {
                _releaseReply ($in);
            }
  } // registerSubgroup


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
  public void castSubgroupCreation (sensei.middleware.domains.DynamicSubgroupInfo info) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("castSubgroupCreation", true);
                sensei.middleware.domains.DynamicSubgroupInfoHelper.write ($out, info);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/SubgroupsHandlerException:1.0"))
                    throw sensei.middleware.domains.SubgroupsHandlerExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                castSubgroupCreation (info        );
            } finally {
                _releaseReply ($in);
            }
  } // castSubgroupCreation


  /**
            * Registers a group dynamically, only possible when the member belongs already to a group and
            * has registered a dynamic subgroups user.
            * When this method is invoked, every member in the group, included this one, receives a invocation
            * through createdSubgroup, and a Subgroup must be supplied.
            * this call blocks until the subgroup is registered, returning the created subgroupId
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups
            **/
  public int createSubgroup (sensei.middleware.domains.DynamicSubgroupInfo info, sensei.middleware.gms.GroupMember subgroup) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("createSubgroup", true);
                sensei.middleware.domains.DynamicSubgroupInfoHelper.write ($out, info);
                sensei.middleware.domains.GroupMemberHelper.write ($out, subgroup);
                $in = _invoke ($out);
                int $result = sensei.middleware.domains.SubgroupIdHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/SubgroupsHandlerException:1.0"))
                    throw sensei.middleware.domains.SubgroupsHandlerExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return createSubgroup (info, subgroup        );
            } finally {
                _releaseReply ($in);
            }
  } // createSubgroup


  /**
            * Removes the given subgroup. Only dynamic subgroups can be removed.
            * If the group is static, an exception is raised. If the subgroup does not exist, false is returned
            * Every member in the group receives a removedSubgroup notification
            * @exception MemberStateException if the member has not yet joined a group, or it has been expulsed
            * @exception SubgroupsHandlerException if the member does not support dynamic groups or the
            *       subgroupId given is describes a static subgroup
            */
  public boolean removeSubgroup (int id, sensei.middleware.domains.DynamicSubgroupInfo info) throws sensei.middleware.domains.MemberStateException, sensei.middleware.domains.SubgroupsHandlerException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("removeSubgroup", true);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, id);
                sensei.middleware.domains.DynamicSubgroupInfoHelper.write ($out, info);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/SubgroupsHandlerException:1.0"))
                    throw sensei.middleware.domains.SubgroupsHandlerExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return removeSubgroup (id, info        );
            } finally {
                _releaseReply ($in);
            }
  } // removeSubgroup


  /**
            * Returns the existing groups, statics and dynamics
            */
  public int[] getSubgroups ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getSubgroups", true);
                $in = _invoke ($out);
                int $result[] = sensei.middleware.domains.SubgroupIdsListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getSubgroups (        );
            } finally {
                _releaseReply ($in);
            }
  } // getSubgroups


  /**
            * Returns the subgroup associated to a given subgroupId, null if not existing
            */
  public sensei.middleware.gms.GroupMember getSubgroup (int id)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getSubgroup", true);
                sensei.middleware.domains.SubgroupIdHelper.write ($out, id);
                $in = _invoke ($out);
                sensei.middleware.gms.GroupMember $result = sensei.middleware.domains.GroupMemberHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getSubgroup (id        );
            } finally {
                _releaseReply ($in);
            }
  } // getSubgroup


  /**
            * Returns the subgroupId for a group. If the group is not valid, EVERY_SUBGROUP is returned
            */
  public int getSubgroupId (sensei.middleware.gms.GroupMember subgroup)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getSubgroupId", true);
                sensei.middleware.domains.GroupMemberHelper.write ($out, subgroup);
                $in = _invoke ($out);
                int $result = sensei.middleware.domains.SubgroupIdHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getSubgroupId (subgroup        );
            } finally {
                _releaseReply ($in);
            }
  } // getSubgroupId

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/SubgroupsHandler:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _SubgroupsHandlerStub
