package sensei.middleware.domains;


/**
* sensei/middleware/domains/_TransactionsHandlerStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Monday, March 15, 2004 12:39:00 AM CET
*/

public class _TransactionsHandlerStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.domains.TransactionsHandler
{


  /**
           * Starts a transaction, locking first the given monitor.
           * Transactions can be nested, but nested transactions only end when the initial transaction
           * is finished.
           * A system on a transaction does not start any state transfer, and all the messages
           * sent by the group handler are queued until the transaction ends. As the result, messages
           * can be seen by other members in different views, and this interface is therefore only
           * allowed under mode MembersOnTransferExcludedFromGroup.
           * @exception MonitorException if the monitor is not valid
           * @exception TransactionException if transactions are not allowed
           */
  public void startTransaction (sensei.middleware.domains.Monitor locker) throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("startTransaction", true);
                sensei.middleware.domains.MonitorHelper.write ($out, locker);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MonitorException:1.0"))
                    throw sensei.middleware.domains.MonitorExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/TransactionException:1.0"))
                    throw sensei.middleware.domains.TransactionExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                startTransaction (locker        );
            } finally {
                _releaseReply ($in);
            }
  } // startTransaction


  /**
           * Ends a transaction, unlocking the given monitor. The operation only takes place, in case
           * of nested transactions, when the initial transaction ends.
           * @exception MonitorException if the monitor used for the transaction has been unlocked inside
           *            the transaction
           * @exception TransactionException if transactions are not allowed, or there is not any current transaction
           */
  public void endTransaction () throws sensei.middleware.domains.MonitorException, sensei.middleware.domains.TransactionException, sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("endTransaction", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MonitorException:1.0"))
                    throw sensei.middleware.domains.MonitorExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/TransactionException:1.0"))
                    throw sensei.middleware.domains.TransactionExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                endTransaction (        );
            } finally {
                _releaseReply ($in);
            }
  } // endTransaction

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/domains/TransactionsHandler:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _TransactionsHandlerStub
