package sensei.middleware.gmns;


/**
* sensei/middleware/gmns/GroupMembershipBasicServicePOA.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:18:51 PM CET
*/


/**
        * this interface allows the creation of new groups and the
        * extension of those groups by adding new members.
        * This service works on GroupMember basis: the service user wanting
        * to join a group must suply a member of that group
        **/
public abstract class GroupMembershipBasicServicePOA extends org.omg.PortableServer.Servant
 implements sensei.middleware.gmns.GroupMembershipBasicServiceOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("getFactoryCreator", new java.lang.Integer (0));
    _methods.put ("createGroup", new java.lang.Integer (1));
    _methods.put ("joinGroup", new java.lang.Integer (2));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
            * Creates a GroupHandlerFactoryCreator
            **/
       case 0:  // sensei/middleware/gmns/GroupMembershipBasicService/getFactoryCreator
       {
         sensei.middleware.gmns.GroupHandlerFactoryCreator $result = null;
         $result = this.getFactoryCreator ();
         out = $rh.createReply();
         sensei.middleware.gmns.GroupHandlerFactoryCreatorHelper.write (out, $result);
         break;
       }


  /**
            * Creates a new group.
            * @param factory A factory creating GroupHandlers on demand
            **/
       case 1:  // sensei/middleware/gmns/GroupMembershipBasicService/createGroup
       {
         try {
           sensei.middleware.gmns.GroupHandlerFactory theFactory = sensei.middleware.gmns.GroupHandlerFactoryHelper.read (in);
           sensei.middleware.gms.GroupHandler $result = null;
           $result = this.createGroup (theFactory);
           out = $rh.createReply();
           sensei.middleware.gms.GroupHandlerHelper.write (out, $result);
         } catch (sensei.middleware.gmns.InvalidGroupHandlerFactoryException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.gmns.InvalidGroupHandlerFactoryExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.gmns.GroupHandlerFactoryException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.gmns.GroupHandlerFactoryExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
            * Extends a group with an additional member
            * @param group a valid handler on a existing group.
            * @returns the group handler created, which can be nil if the member
            *    could not join the group because was considered faulty or because
            *    the groupHandler used is not valid or has been expulsed from the group
            **/
       case 2:  // sensei/middleware/gmns/GroupMembershipBasicService/joinGroup
       {
         try {
           sensei.middleware.gms.GroupHandler group = sensei.middleware.gmns.GroupHandlerHelper.read (in);
           sensei.middleware.gmns.GroupHandlerFactory theFactory = sensei.middleware.gmns.GroupHandlerFactoryHelper.read (in);
           sensei.middleware.gms.GroupHandler $result = null;
           $result = this.joinGroup (group, theFactory);
           out = $rh.createReply();
           sensei.middleware.gms.GroupHandlerHelper.write (out, $result);
         } catch (sensei.middleware.gmns.InvalidGroupHandlerException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.gmns.InvalidGroupHandlerExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.gmns.InvalidGroupHandlerFactoryException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.gmns.InvalidGroupHandlerFactoryExceptionHelper.write (out, $ex);
         } catch (sensei.middleware.gmns.GroupHandlerFactoryException $ex) {
           out = $rh.createExceptionReply ();
           sensei.middleware.gmns.GroupHandlerFactoryExceptionHelper.write (out, $ex);
         }
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/gmns/GroupMembershipBasicService:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public GroupMembershipBasicService _this() 
  {
    return GroupMembershipBasicServiceHelper.narrow(
    super._this_object());
  }

  public GroupMembershipBasicService _this(org.omg.CORBA.ORB orb) 
  {
    return GroupMembershipBasicServiceHelper.narrow(
    super._this_object(orb));
  }


} // class GroupMembershipBasicServicePOA
