package sensei.middleware.gmns;


/**
* sensei/middleware/gmns/_GroupMembershipBasicServiceStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:18:51 PM CET
*/


/**
        * this interface allows the creation of new groups and the
        * extension of those groups by adding new members.
        * This service works on GroupMember basis: the service user wanting
        * to join a group must suply a member of that group
        **/
public class _GroupMembershipBasicServiceStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.gmns.GroupMembershipBasicService
{


  /**
            * Creates a GroupHandlerFactoryCreator
            **/
  public sensei.middleware.gmns.GroupHandlerFactoryCreator getFactoryCreator ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getFactoryCreator", true);
                $in = _invoke ($out);
                sensei.middleware.gmns.GroupHandlerFactoryCreator $result = sensei.middleware.gmns.GroupHandlerFactoryCreatorHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getFactoryCreator (        );
            } finally {
                _releaseReply ($in);
            }
  } // getFactoryCreator


  /**
            * Creates a new group.
            * @param factory A factory creating GroupHandlers on demand
            **/
  public sensei.middleware.gms.GroupHandler createGroup (sensei.middleware.gmns.GroupHandlerFactory theFactory) throws sensei.middleware.gmns.InvalidGroupHandlerFactoryException, sensei.middleware.gmns.GroupHandlerFactoryException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("createGroup", true);
                sensei.middleware.gmns.GroupHandlerFactoryHelper.write ($out, theFactory);
                $in = _invoke ($out);
                sensei.middleware.gms.GroupHandler $result = sensei.middleware.gmns.GroupHandlerHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/gmns/InvalidGroupHandlerFactoryException:1.0"))
                    throw sensei.middleware.gmns.InvalidGroupHandlerFactoryExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/gmns/GroupHandlerFactoryException:1.0"))
                    throw sensei.middleware.gmns.GroupHandlerFactoryExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return createGroup (theFactory        );
            } finally {
                _releaseReply ($in);
            }
  } // createGroup


  /**
            * Extends a group with an additional member
            * @param group a valid handler on a existing group.
            * @returns the group handler created, which can be nil if the member
            *    could not join the group because was considered faulty or because
            *    the groupHandler used is not valid or has been expulsed from the group
            **/
  public sensei.middleware.gms.GroupHandler joinGroup (sensei.middleware.gms.GroupHandler group, sensei.middleware.gmns.GroupHandlerFactory theFactory) throws sensei.middleware.gmns.InvalidGroupHandlerException, sensei.middleware.gmns.InvalidGroupHandlerFactoryException, sensei.middleware.gmns.GroupHandlerFactoryException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("joinGroup", true);
                sensei.middleware.gmns.GroupHandlerHelper.write ($out, group);
                sensei.middleware.gmns.GroupHandlerFactoryHelper.write ($out, theFactory);
                $in = _invoke ($out);
                sensei.middleware.gms.GroupHandler $result = sensei.middleware.gmns.GroupHandlerHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/gmns/InvalidGroupHandlerException:1.0"))
                    throw sensei.middleware.gmns.InvalidGroupHandlerExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/gmns/InvalidGroupHandlerFactoryException:1.0"))
                    throw sensei.middleware.gmns.InvalidGroupHandlerFactoryExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/gmns/GroupHandlerFactoryException:1.0"))
                    throw sensei.middleware.gmns.GroupHandlerFactoryExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return joinGroup (group, theFactory        );
            } finally {
                _releaseReply ($in);
            }
  } // joinGroup

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/gmns/GroupMembershipBasicService:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _GroupMembershipBasicServiceStub
