package sensei.middleware.gmns;


/**
* sensei/middleware/gmns/_GroupMembershipNamingServiceStub.java .
* Error reading Messages File.
* Error reading Messages File.
* Sunday, March 7, 2004 3:18:51 PM CET
*/


/**
        * The Group Member Naming Service is a naming service for reliable
        * Group Members. It allows to join groups just by specifying the
        * group name. This service will locate other members in the group,
        * or will just create the group.
        * This service is not compatible with the GroupMembershipBasicService,
        * members added to groups using that service are unknown on this
        * Naming Service.
        **/
public class _GroupMembershipNamingServiceStub extends org.omg.CORBA.portable.ObjectImpl implements sensei.middleware.gmns.GroupMembershipNamingService
{


  /**
            * Creates a GroupHandlerFactoryCreator
            **/
  public sensei.middleware.gmns.GroupHandlerFactoryCreator getFactoryCreator ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getFactoryCreator", true);
                $in = _invoke ($out);
                sensei.middleware.gmns.GroupHandlerFactoryCreator $result = sensei.middleware.gmns.GroupHandlerFactoryCreatorHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getFactoryCreator (        );
            } finally {
                _releaseReply ($in);
            }
  } // getFactoryCreator


  /**
            * Finds a group with the name specified and includes the member with the given name
            * The reference can be null if the member is no accesible to clients
            * @returns the group handler created, or null if this member has been considered by
            *  the group.
            * @exception MemberStateException if the member defining the service cannot contact
            *  other members and decide surely about the joining
            **/
  public sensei.middleware.gms.GroupHandler findAndJoinGroup (String groupName, sensei.middleware.gmns.GroupHandlerFactory theFactory, String memberName, sensei.middleware.gmns.ReplicatedServer clientsReference) throws sensei.middleware.domains.MemberStateException, sensei.middleware.gmns.InvalidGroupHandlerFactoryException, sensei.middleware.gmns.GroupHandlerFactoryException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("findAndJoinGroup", true);
                $out.write_string (groupName);
                sensei.middleware.gmns.GroupHandlerFactoryHelper.write ($out, theFactory);
                $out.write_string (memberName);
                sensei.middleware.gmns.ReplicatedServerHelper.write ($out, clientsReference);
                $in = _invoke ($out);
                sensei.middleware.gms.GroupHandler $result = sensei.middleware.gmns.GroupHandlerHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/gmns/InvalidGroupHandlerFactoryException:1.0"))
                    throw sensei.middleware.gmns.InvalidGroupHandlerFactoryExceptionHelper.read ($in);
                else if (_id.equals ("IDL:sensei/middleware/gmns/GroupHandlerFactoryException:1.0"))
                    throw sensei.middleware.gmns.GroupHandlerFactoryExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return findAndJoinGroup (groupName, theFactory, memberName, clientsReference        );
            } finally {
                _releaseReply ($in);
            }
  } // findAndJoinGroup


  /**
            * Leaves a group. This method is not needed to be called, as the service can
            * discover by itself that a member has left the group, but it can speed up
            * other member's joining.
            **/
  public void leaveGroup (String groupName, sensei.middleware.gms.GroupHandler member)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("leaveGroup", true);
                $out.write_string (groupName);
                sensei.middleware.gmns.GroupHandlerHelper.write ($out, member);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                leaveGroup (groupName, member        );
            } finally {
                _releaseReply ($in);
            }
  } // leaveGroup


  /**
            * Returns the know references to a group, which can be still not valid. The list
            * is empty if there are no servers in the group or the group does not exist
            **/
  public sensei.middleware.gmns.ReplicatedServer[] getGroup (String groupName) throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getGroup", true);
                $out.write_string (groupName);
                $in = _invoke ($out);
                sensei.middleware.gmns.ReplicatedServer $result[] = sensei.middleware.gmns.ReplicatedServersListHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getGroup (groupName        );
            } finally {
                _releaseReply ($in);
            }
  } // getGroup


  /**
            * Returns a specific reference of a member in the group. If
            * the group does not exist or it contains no such a member, null is returned
            **/
  public sensei.middleware.gmns.ReplicatedServer getGroupServer (String groupName, String memberName) throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getGroupServer", true);
                $out.write_string (groupName);
                $out.write_string (memberName);
                $in = _invoke ($out);
                sensei.middleware.gmns.ReplicatedServer $result = sensei.middleware.gmns.ReplicatedServerHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getGroupServer (groupName, memberName        );
            } finally {
                _releaseReply ($in);
            }
  } // getGroupServer


  /**
            * Returns a reference to a member in the group, warrantied to be valid. Note that it can
            * get invalidated before the client received it.
            **/
  public sensei.middleware.gmns.ReplicatedServer getValidGroupServer (String groupName) throws sensei.middleware.domains.MemberStateException
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getValidGroupServer", true);
                $out.write_string (groupName);
                $in = _invoke ($out);
                sensei.middleware.gmns.ReplicatedServer $result = sensei.middleware.gmns.ReplicatedServerHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                if (_id.equals ("IDL:sensei/middleware/domains/MemberStateException:1.0"))
                    throw sensei.middleware.domains.MemberStateExceptionHelper.read ($in);
                else
                    throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getValidGroupServer (groupName        );
            } finally {
                _releaseReply ($in);
            }
  } // getValidGroupServer

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:sensei/middleware/gmns/GroupMembershipNamingService:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _GroupMembershipNamingServiceStub
