/*
 * Main.java
 *
 * Created on 31 January 2001, 02:08
 */

package senseiTests.chat.middleware;

import java.util.Properties;

import org.omg.CORBA.ORB;

import sensei.middleware.gms.GroupMember;
import sensei.middleware.gms.ORBcentral;

/**
 *
 * @author  Administrator
 * @version
 */
public abstract class MainBase extends java.lang.Object {

	/** Creates new Main */
	public MainBase(String args[]) {
		ORB orb = null;
		try {
			Properties props = System.getProperties();

			//      args=vnet2.OOCInterceptor.setup(null, args, props);//only change for virtual net

			orb = ORB.init(args, props);

			ORBcentral.setORB(orb);
			ChatMessageFactory.register();

			if (joinGMNS(new ChatMember().theGroupMember())){
				orb.run();
			}
		}
		catch (Exception ex) {
			ex.printStackTrace();
		}
		if (orb != null)
			try {
				orb.destroy();
			}
			catch (Exception ex) {
			}
	}
	
	protected abstract boolean joinGMNS(GroupMember impl) throws Exception;

}
