package senseiTests.performanceGMS.middleware;

import org.omg.CORBA.portable.ValueFactory;
import org.omg.CORBA_2_3.portable.InputStream;

import sensei.middleware.gms.Message;
import sensei.middleware.gms.MessageHelper;
import sensei.middleware.gms.ORBcentral;

public abstract class MainBase implements Factory{

	protected MainBase(String name, int n, String args[]) {
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, System.getProperties());
		ORBcentral.setORB(orb);
		((org.omg.CORBA_2_3.ORB) orb).register_value_factory(MessageHelper.id(), new ValueFactory() {
			public java.io.Serializable read_value(InputStream in) {
				return in.read_value(new Message() {
				});
			}
		});
		try{
			createMainInstance(args[0], n);
		}
		catch(Exception ex){
			ex.printStackTrace();
		}
		orb.run();
	}

	protected abstract void createMainInstance(String name, int n) throws Exception;
}
