/**
  * File: 		MonitorState.java
  * Content: 	part of the RMI specification of sensei domains
  *           Defines a structure with the state of a group monitor (list of lockers)
  * Author: 	LuisM Pena
  * Date: 		27th October 2001
  * Version:  0.51.00
  * Last change:
  *
  **/


package sensei.middleware.domains;

/**
 * Defines a structure with the state of a group monitor (list of lockers)
 */
public class MonitorState implements State
{
    public int[] locks;
}
