/**
  * File: 		MapStringSetObservable.java
  * Content: 	part of the RMI specification of sensei gmns
  * Author: 	LuisM Pena
  * Date: 		1st December 2001
  * Version:  0.29.00
  * Last change:
  *
  **/


package sensei.middleware.gmns;

import java.rmi.Remote;
import java.rmi.RemoteException;

public interface MapStringSetObserver extends Remote
{
  public void clearDone(MapStringSetObservable observable) throws RemoteException;
  public void putDone(MapStringSetObservable observable, String groupName, SetMemberInfo set) throws RemoteException;
  public void removeDone(MapStringSetObservable observable, String groupName, SetMemberInfo set)
    throws RemoteException;
}
