/**
  * File: AllowTokenRecoveryAnswer.java
  * Content: part of the RMI specification of members with reliable multicast
  *          communications, based on the virtual synchronous model
  * Author: LuisM Pena
  * Date: 31th July 2000
  * Version: 0.80.00
  * Last change:
  *
  **/

package sensei.middleware.gms;

final public class AllowTokenRecoveryAnswer implements java.io.Serializable {
	public AllowTokenRecoveryAnswer() {
	}

	public AllowTokenRecoveryAnswer(boolean validCommunication, boolean recoveryAllowed, MessageId lastMessage) {
		this.validCommunication = validCommunication;
		this.recoveryAllowed = recoveryAllowed;
		this.lastMessage = lastMessage;
	}

	public boolean validCommunication;
	public boolean recoveryAllowed;
	public MessageId lastMessage;
}
