/**
  * File: GMSnarrower.java
  * Content: Utility class performing narrow operations for GMS middleware objects
  * Author: LuisM Pena
  * Date: 15th December 2000
  * Version: 0.80.00
  * Last change:
  *
  **/

package sensei.middleware.gms;

/**
  * Utility class performing narrow operations for GMS middleware objects
  **/
public class GMSnarrower {

	public final static GroupHandler toGroupHandler(Object object) {
		return object instanceof GroupHandler ? (GroupHandler) object : null;
	}

	public final static GroupMember toGroupMember(Object object) {
		return object instanceof GroupMember ? (GroupMember) object : null;
	}

	public final static SenseiGMSMember toSenseiGMSMember(Object object) {
		return object instanceof SenseiGMSMember ? (SenseiGMSMember) object : null;
	}

}
