/**
  * File: ShutdownHooker.java
  * Content: Defines the interface to be implemented by ShutdownHook clients
  * Author: LuisM Pena
  * Date: 4th November 2000
  * Version: 0.97.00
  * Last change:
  *
  **/

package sensei.util;

public interface ShutdownHooker {
	/**
	  * This method is called when the Java VM is shutting down.
	  **/
	public void shuttingDown();
}
